diff --git a/gprofng/common/gp-experiment.h b/gprofng/common/gp-experiment.h
index 210ec60c98e..41aaebe5162 100644
--- a/gprofng/common/gp-experiment.h
+++ b/gprofng/common/gp-experiment.h
@@ -30,8 +30,6 @@
 
 #include "Emsgnum.h" /* for COL_ERROR_*, etc. symbols */
 
-#define SP_REMOTE_PROTOCOL_VERSION "12.4.1"
-
 #define SP_GROUP_HEADER         "#analyzer experiment group"
 
 /* Experiment name macro definitions */
diff --git a/gprofng/common/hwctable.c b/gprofng/common/hwctable.c
index d0735132fac..567f49f80d5 100644
--- a/gprofng/common/hwctable.c
+++ b/gprofng/common/hwctable.c
@@ -27,12 +27,6 @@
 
 #include "hwcdrv.h"
 
-/* TprintfT(<level>,...) definitions.  Adjust per module as needed */
-#define DBG_LT0 0 // for high-level configuration, unexpected errors/warnings
-#define DBG_LT1 1 // for configuration details, warnings
-#define DBG_LT2 2
-#define DBG_LT3 3
-
 /*---------------------------------------------------------------------------*/
 /* compile options */
 
diff --git a/gprofng/libcollector/envmgmt.c b/gprofng/libcollector/envmgmt.c
index ebe08f82007..a399c0d0cb4 100644
--- a/gprofng/libcollector/envmgmt.c
+++ b/gprofng/libcollector/envmgmt.c
@@ -27,13 +27,6 @@
 
 #define MAX_LD_PRELOADS 2
 
-/* TprintfT(<level>,...) definitions.  Adjust per module as needed */
-#define DBG_LT0 0 // for high-level configuration, unexpected errors/warnings
-#define DBG_LT1 1 // for configuration details, warnings
-#define DBG_LT2 2
-#define DBG_LT3 3
-#define DBG_LT4 4
-
 /* original environment settings to be saved for later restoration */
 static char *sp_preloads[MAX_LD_PRELOADS];
 static char *sp_libpaths[MAX_LD_PRELOADS];
diff --git a/gprofng/libcollector/hwprofile.c b/gprofng/libcollector/hwprofile.c
index 841a3717e37..364c600968a 100644
--- a/gprofng/libcollector/hwprofile.c
+++ b/gprofng/libcollector/hwprofile.c
@@ -41,14 +41,6 @@
 #include "ABS.h"
 #include "tsd.h"
 
-/* TprintfT(<level>,...) definitions.  Adjust per module as needed */
-#define DBG_LT0 0 // for high-level configuration, unexpected errors/warnings
-#define DBG_LT1 1 // for configuration details, warnings
-#define DBG_LT2 2
-#define DBG_LT3 3
-#define DBG_LT4 4
-#define DBG_LT5 5
-
 #define  SD_OFF 0       /* before start or after close she shut down process */
 #define  SD_PENDING 1   /* before running real_detach_experiment() */
 #define  SD_COMPLETE 2  /* after running real_detach_experiment() */
diff --git a/gprofng/libcollector/iolib.c b/gprofng/libcollector/iolib.c
index a671781fcda..9f210589dfa 100644
--- a/gprofng/libcollector/iolib.c
+++ b/gprofng/libcollector/iolib.c
@@ -36,12 +36,6 @@
 #include "gp-experiment.h"
 #include "memmgr.h"
 
-/* TprintfT(<level>,...) definitions.  Adjust per module as needed */
-#define DBG_LT0 0 // for high-level configuration, unexpected errors/warnings
-#define DBG_LT1 1 // for configuration details, warnings
-#define DBG_LT2 2
-#define DBG_LT3 3
-
 /* ------------- Data and prototypes for block management --------- */
 #define IO_BLK      0 /* Concurrent requests */
 #define IO_SEQ      1 /* All requests are sequential, f.e. JAVA_CLASSES */
diff --git a/gprofng/libcollector/jprofile.c b/gprofng/libcollector/jprofile.c
index 1bacacc1a2a..2cabb1a08de 100644
--- a/gprofng/libcollector/jprofile.c
+++ b/gprofng/libcollector/jprofile.c
@@ -37,12 +37,6 @@
 #include "gp-experiment.h"
 #include "tsd.h"
 
-/* TprintfT(<level>,...) definitions.  Adjust per module as needed */
-#define DBG_LT0 0 // for high-level configuration, unexpected errors/warnings
-#define DBG_LT1 1 // for configuration details, warnings
-#define DBG_LT2 2
-#define DBG_LT3 3
-
 /* ARCH_STRLEN is defined in dbe, copied here */
 #define ARCH_STRLEN(s)      ((CALL_UTIL(strlen)(s) + 4 ) & ~0x3)
 
diff --git a/gprofng/libcollector/memmgr.c b/gprofng/libcollector/memmgr.c
index 6a8b0861bd3..c4109b656e3 100644
--- a/gprofng/libcollector/memmgr.c
+++ b/gprofng/libcollector/memmgr.c
@@ -30,13 +30,6 @@
 #include "gp-experiment.h"
 #include "memmgr.h"
 
-/* TprintfT(<level>,...) definitions.  Adjust per module as needed */
-#define DBG_LT0 0 // for high-level configuration, unexpected errors/warnings
-#define DBG_LT1 1 // for configuration details, warnings
-#define DBG_LT2 2
-#define DBG_LT3 3
-#define DBG_LT4 4
-
 /*
  * Memory allocation.
  *
diff --git a/gprofng/libcollector/profile.c b/gprofng/libcollector/profile.c
index dbaa36d251c..127fd6917bb 100644
--- a/gprofng/libcollector/profile.c
+++ b/gprofng/libcollector/profile.c
@@ -41,12 +41,6 @@
 #include "hwprofile.h"
 #include "tsd.h"
 
-/* TprintfT(<level>,...) definitions.  Adjust per module as needed */
-#define DBG_LT0 0 // for high-level configuration, unexpected errors/warnings
-#define DBG_LT1 1 // for configuration details, warnings
-#define DBG_LT2 2
-#define DBG_LT3 3
-
 static int init_interface (CollectorInterface*);
 static int open_experiment (const char *);
 static int start_data_collection (void);
@@ -268,7 +262,7 @@ __collector_ext_profile_handler (siginfo_t *info, ucontext_t *context)
       return;
     }
   PUSH_REENTRANCE (guard);
-  TprintfT (DBG_LT3, "__collector_ext_profile_handler\n");
+  TprintfT (0, "__collector_ext_profile_handler\n");
   ucontext_t uctxmem;
   if (context == NULL)
     {
diff --git a/gprofng/libcollector/tsd.c b/gprofng/libcollector/tsd.c
index 80d6a1cc8a4..a92e35a98fc 100644
--- a/gprofng/libcollector/tsd.c
+++ b/gprofng/libcollector/tsd.c
@@ -26,12 +26,6 @@
 #include "tsd.h"
 #include "memmgr.h"
 
-/* TprintfT(<level>,...) definitions.  Adjust per module as needed */
-#define DBG_LT0 0 // for high-level configuration, unexpected errors/warnings
-#define DBG_LT1 1 // for configuration details, warnings
-#define DBG_LT2 2
-#define DBG_LT3 3
-
 /*
  * Build our thread-specific-data support on pthread interfaces.
  */
diff --git a/gprofng/libcollector/unwind.c b/gprofng/libcollector/unwind.c
index 91678b1e334..e62da04433c 100644
--- a/gprofng/libcollector/unwind.c
+++ b/gprofng/libcollector/unwind.c
@@ -60,12 +60,6 @@ struct frame
 };
 #endif
 
-/* Set the debug trace level */
-#define DBG_LT0 0
-#define DBG_LT1	1
-#define DBG_LT2	2
-#define DBG_LT3	3
-
 int (*__collector_VM_ReadByteInstruction)(unsigned char *) = NULL;
 #define VM_NO_ACCESS        (-1)
 #define VM_NOT_VM_MEMORY    (-2)